hkm/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import url
from django.contrib.auth.decorators import login_required

from hkm.views import views
from hkm.decorators import restrict_for_museum
from hkm.views.checkout import OrderContactFormView, OrderSummaryView, OrderPBWNotify, OrderConfirmation

urlpatterns = [
    url(r'^$', views.HomeView.as_view(), name='hkm_home'),
    url(r'^info/$', views.InfoView.as_view(), name='hkm_info'),

    url(r'^about/$', views.SiteinfoAboutView.as_view(), name='hkm_siteinfo_about'),
    url(r'^accessibility/$', views.SiteinfoAccessibilityView.as_view(), name='hkm_siteinfo_accessibility'),
    url(r'^privacy/$', views.SiteinfoPrivacyView.as_view(),
        name='hkm_siteinfo_privacy'),
    url(r'^QA/$', views.SiteinfoQAView.as_view(), name='hkm_siteinfo_QA'),
    url(r'^terms/$', views.SiteinfoTermsView.as_view(), name='hkm_siteinfo_terms'),

    url(r'^collection/public/$', views.PublicCollectionsView.as_view(),
        name='hkm_public_collections'),
    url(r'^collection/my/$', restrict_for_museum(login_required()
        (views.MyCollectionsView.as_view())), name='hkm_my_collections'),
    url(r'^collection/(?P<collection_id>\d+)/$',
        views.CollectionDetailView.as_view(), name='hkm_collection'),

    url(r'^search/$', views.SearchView.as_view(), name='hkm_search'),
    url(r'^search/details/$', views.SearchRecordDetailView.as_view(),
        name='hkm_search_record'),
    url(r'^record/feedback/$', views.RecordFeedbackView.as_view(), name='hkm_record_feedback'),
    url(r'^record/(?P<finna_id>[a-zA-Z0-9:.]+)/$', views.LegacyRecordDetailView.as_view(),
        name='hkm_legacy_record_details'),

    url(r'^signup/$', restrict_for_museum(views.SignUpView.as_view()), name='hkm_signup'),
    url(r'^language/$', views.LanguageView.as_view(), name='hkm_language'),

    url(r'^order/contact/$', restrict_for_museum(OrderContactFormView.as_view()), name='hkm_order_contact'),
    url(r'^order/summary/$', restrict_for_museum(OrderSummaryView.as_view()), name='hkm_order_summary'),

    url(r'^order/(?P<finna_id>[a-zA-Z0-9:.]+)/$',
        views.CreateOrderView.as_view(), name='hkm_order_create'),
    url(r'^order/(?P<order_id>[a-zA-Z0-9]+)/product/$',
        views.OrderProductView.as_view(), name='hkm_order_product'),
    url(r'^order/(?P<order_id>[a-zA-Z0-9]+)/confirmation/$',
        restrict_for_museum(OrderConfirmation.as_view()), name='hkm_order_confirmation'),
    url(r'^order/(?P<order_id>[a-zA-Z0-9]+)/notify/$',
        restrict_for_museum(OrderPBWNotify.as_view()), name='hkm_order_pbw_notify'),
    url(r'^ajax/record/fav/$', restrict_for_museum(login_required()(views.AjaxUserFavoriteRecordView.as_view())),
        name='hkm_ajax_record_fav'),
    url(r'^ajax/crop/$', views.AjaxCropRecordView.as_view(),
        name='hkm_ajax_crop'),
    url(r'^ajax/collection/$', views.AjaxAddToCollection.as_view(),
        name='hkm_add_to_collection'),
    url(r'^basket/$', views.BasketView.as_view(), name='basket'),
    url(r'^basket/checkout/$', views.BasketView.as_view(), {"phase": "checkout"}, name='checkout'),
]

kuvaselaamo/urls.py
# -*- coding: utf-8 -*-

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.http import HttpResponse


class AdminSite(admin.AdminSite):
    def has_permission(self, request):
        return request.user.is_active and request.user.is_staff and request.user.is_superuser


admin.site = AdminSite()
admin.autodiscover()

handler404 = 'hkm.views.views.handler404'
handler500 = 'hkm.views.views.handler500'

admin_urls = [
    url(r'^sysadmin/', include(admin.site.urls)),
]

app_urls = [
    url(r'^', include('hkm.urls')),
]

auth_urls = [
    url(r'^', include('django.contrib.auth.urls')),
]

static_urls = static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
static_urls += staticfiles_urlpatterns()

urlpatterns = admin_urls + app_urls + static_urls + auth_urls

if settings.DEBUG:
    from django.views.generic import TemplateView

    class ServerError(TemplateView):
        template_name = '500.html'

    class PageNotFoundError(TemplateView):
        template_name = '404.html'

    urlpatterns += [
        url(r'^500/$', ServerError.as_view()),
        url(r'^404/$', PageNotFoundError.as_view()),
    ]


#
# Kubernetes liveness & readiness probes
#
def healthz(*args, **kwargs):
    return HttpResponse(status=200)


def readiness(*args, **kwargs):
    return HttpResponse(status=200)


urlpatterns += [
    url(r'^healthz', healthz),
    url(r'^readiness', readiness)
]

hkm/forms.py
# -*- coding: utf-8 -*-

import logging

from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.utils.translation import ugettext_lazy as _
from django.core.exceptions import ValidationError

from hkm.models.campaigns import CampaignCode
from hkm.models.models import Collection, Feedback, ProductOrder, ProductOrderCollection, Showcase

LOG = logging.getLogger(__name__)


class CollectionForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.user = kwargs.pop('user')
        super(CollectionForm, self).__init__(*args, **kwargs)
        if not self.user.is_authenticated() or not self.user.profile.is_admin:
            del self.fields['show_in_landing_page']
            del self.fields['is_featured']

    class Meta:
        model = Collection
        fields = ['title', 'description', 'is_public',
                  'show_in_landing_page', 'is_featured']


class FeedbackForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.user = kwargs.pop('user', None)
        return super(FeedbackForm, self).__init__(*args, **kwargs)

    def save(self, *args, **kwargs):
        commit = kwargs.get('commit', True)
        kwargs['commit'] = False
        feedback = super(FeedbackForm, self).save(*args, **kwargs)
        feedback.user = self.user
        if commit:
            feedback.save()
        return feedback

    class Meta:
        model = Feedback
        fields = ['content', 'full_name', 'email']


class OrderProductForm(forms.ModelForm):
    class Meta:
        model = ProductOrder
        fields = ['amount']


class OrderContactInformationForm(forms.ModelForm):
    class Meta:
        model = ProductOrder
        fields = ['first_name', 'last_name', 'email',
                  'phone', 'street_address', 'postal_code', 'city']


class RegistrationForm(UserCreationForm):
    def __init__(self, *args, **kwargs):
        super(RegistrationForm, self).__init__(*args, **kwargs)

        self.fields['email'].required = True

    class Meta:
        model = User
        fields = ['username', 'email']


class ProductOrderCollectionForm(forms.ModelForm):
    action = forms.CharField(widget=forms.HiddenInput(attrs={'value': 'checkout'}))
    orderer_name = forms.CharField(required=False, widget=forms.TextInput(attrs={'class': 'form-control'}),
                                   label=_(u"Orderer's name"))

    class Meta:
        model = ProductOrderCollection
        fields = ['orderer_name']


class GenerateCampaignCodesActionForm(forms.Form):
    code_prefix = forms.CharField(
        required=False,
        widget=forms.TextInput,
    )
    code_length = forms.CharField(
        required=False,
        widget=forms.TextInput,
    )
    amount = forms.IntegerField(
        required=False,
    )

    def form_action(self, campaign):
        for i in range(0, self.cleaned_data["amount"]):
            code = CampaignCode(campaign=campaign)
            code.generate_code(
                length=self.cleaned_data["code_length"],
                prefix=self.cleaned_data["code_prefix"],
            )
            code.save()

    # def save(self, campaign):
    #     try:
    #         account, action = self.form_action(account, user)
    #     except errors.Error as e:
    #         error_message = str(e)
    #         self.add_error(None, error_message)
    #         raise
    #
    #     return account, action


class ShowcaseForm(forms.ModelForm):
    class Meta:
        model = Showcase
        fields = ['title', 'albums', 'show_on_home_page']

    def clean(self):
        albums = self.cleaned_data.get('albums')

        if albums:
            if albums.count() > 3:
                raise ValidationError(_(u'Max amount of albums is three'))
        return self.cleaned_data

hkm/views/checkout.py
import logging

from django.conf import settings
from django.core.exceptions import ObjectDoesNotExist
from django.http import HttpResponse, Http404, HttpResponseForbidden
from django.shortcuts import redirect
from django.urls import reverse
from django.utils import timezone
from django.utils.translation import LANGUAGE_SESSION_KEY
from django.views import View
from django.views.generic import TemplateView

from hkm.basket.order_creator import OrderCreator
from hkm.forms import OrderContactInformationForm
from hkm.models.models import ProductOrder, ProductOrderCollection

LOG = logging.getLogger(__name__)


class BaseCheckoutView(TemplateView):
    url_name = None

    def get_context_data(self, **kwargs):
        context = super(TemplateView, self).get_context_data(**kwargs)
        context['language'] = self.request.session.get(LANGUAGE_SESSION_KEY, settings.LANGUAGE_CODE)
        return context


class OrderContactFormView(BaseCheckoutView):
    template_name = 'hkm/views/order_contact_information.html'
    url_name = 'hkm_order_contact_information'

    def __init__(self):
        super(OrderContactFormView, self).__init__()

    def post(self, request, *args, **kwargs):
        action = request.POST.get('action', None)
        if action == 'order-contact-info':
            return self.handle_order_contact_info(request, *args, **kwargs)
        return super(OrderContactFormView, self).post(request, *args, **kwargs)

    def handle_order_contact_info(self, request, *args, **kwargs):
        form = OrderContactInformationForm(request.POST, prefix='order-contact-information-form')

        if form.is_valid():
            form.cleaned_data['form_phase'] = 3
            ProductOrder.objects.filter(
                pk__in=[line.order_pk for line in request.basket.product_lines]
            ).update(**form.cleaned_data)

            return redirect(reverse('hkm_order_summary'))
        kwargs['order_contact_information_form'] = form
        return self.get(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(OrderContactFormView, self).get_context_data(**kwargs)
        context['form_page'] = 2
        order = ProductOrder.objects.filter(
            pk__in=[line.order_pk for line in self.request.basket.product_lines]
        ).first()
        context['order'] = order
        context['order_contact_information_form'] = OrderContactInformationForm(
            prefix='order-contact-information-form',
            instance=order or ProductOrder()
        )
        return context


class OrderSummaryView(BaseCheckoutView):
    template_name = 'hkm/views/order_summary.html'
    url_name = 'hkm_order_summary'

    def post(self, request, *args, **kwargs):
        action = request.POST.get('action', None)
        if action == 'order-submit':
            order_creator = OrderCreator()
            if not order_creator.validate_basket(request.basket):
                raise
            order_collection = order_creator.create_order_from_basket(request.basket)

            datetime_checkout_started = timezone.now()
            LOG.debug('ORDER ATTEMPT STARTED AT: ',
                extra={
                    'data': {
                        'order_hash': order_collection.order_hash,
                        'time': str(datetime_checkout_started)
                    }
                })

            # If order total price is 0, skip payment api and redirect straight to confirmation view
            if order_collection.is_zero_price:
                return redirect(reverse('hkm_order_confirmation', kwargs={"order_id": order_collection.order_hash}))

            redirect_url = order_collection.checkout()
            if redirect_url:
                return redirect(redirect_url)

        # TODO error messaging for user in UI
        return redirect(reverse('hkm_order_summary'))

    def get_context_data(self, **kwargs):
        context = super(OrderSummaryView, self).get_context_data(**kwargs)
        context['form_page'] = 3
        order = ProductOrder.objects.filter(
            pk__in=[line.order_pk for line in self.request.basket.product_lines]
        ).first()
        context['order'] = order
        return context

# Payment Provider GETs this route after payment has been processed to notify of success/failure
# In testing API there is never time lag with this, but in real system
# there can be


class OrderPBWNotify(View):
    template_name = ''
    url_name = 'hkm_order_pbw_notify'
    result = {}

    def get(self, request, *args, **kwargs):

        self.result['authcode'] = request.GET.get('AUTHCODE', None)
        self.result['return_code'] = request.GET.get('RETURN_CODE', None)
        self.result['order_hash'] = request.GET.get('ORDER_NUMBER', None)
        self.result['settled'] = request.GET.get('SETTLED', None)
        self.result['incident_id'] = request.GET.get('INCIDENT_ID', None)
        order_collection = ProductOrderCollection.objects.get(order_hash=self.result['order_hash'])

        if order_collection.authcode_valid(self.result):
            order_collection.handle_confirmation(self.result)
        else:
            LOG.error('AUTHCODE MISMATCH! ', extra={
                    'data': {'order_hash': order_collection.order_hash}})

        return HttpResponse()


# User is redirected to this route from Payment Provider after payment
# With a success return code, the user is displayed a success message
# If and only if the request parameter 'settled' is true, the order will
# be sent to print


class OrderConfirmation(BaseCheckoutView):
    template_name = 'hkm/views/order_show_result.html'
    url_name = 'hkm_order_confirmation'
    result = {}

    def get(self, request, *args, **kwargs):

        self.result['authcode'] = request.GET.get('AUTHCODE', None)
        self.result['return_code'] = request.GET.get('RETURN_CODE', None)
        self.result['order_hash'] = request.GET.get('ORDER_NUMBER', kwargs.get("order_id"))
        self.result['settled'] = request.GET.get('SETTLED', None)
        self.result['incident_id'] = request.GET.get('INCIDENT_ID', None)
        try:
            self.order_collection = ProductOrderCollection.objects.get(order_hash=self.result['order_hash'])
        except ObjectDoesNotExist:
            return HttpResponseForbidden()
        if self.order_collection.is_zero_price:
            self.order_collection.handle_zero_price_confirmation()
            request.basket.clear_all()
        elif self.order_collection.authcode_valid(self.result):
            self.order_collection.handle_confirmation(self.result)
            request.basket.clear_all()
        else:
            LOG.error('AUTHCODE MISMATCH! ', extra={
                    'data': {'order_hash': self.order_collection.order_hash}})
            return HttpResponseForbidden()
        return super(OrderConfirmation, self).get(request, args, kwargs)

    def get_context_data(self, **kwargs):
        context = super(OrderConfirmation, self).get_context_data(**kwargs)
        context['order_collection'] = self.order_collection
        context['order'] = self.order_collection.product_orders.first()
        return context

hkm/templates/hkm/snippets/_basket_total_row.html
{% load i18n hkm_tags %}
<h5>{% trans 'Total' %}&nbsp;
    {{ request.basket.basket_total_price|localized_decimal:2 }} € +
    {% if not request.basket.is_free_shipping  %}
        {% trans 'Shipping fees' %} {{ request.basket.postal_fee }} €
    {% else %}
        <span class="no-postal-fee">{% trans 'Shipping fees' %} {{ request.basket.postal_fee }} €</span> 0 €
    {% endif %}
    = <span class="basket-price-value">{{ request.basket.total_price_with_postal_fees|localized_decimal:2 }} </span> {% trans 'Incl. VAT' %}
</h5>

hkm/templates/hkm/snippets/form_fields.html
{% load i18n widget_tweaks %}

{% for field in form %}
  {% if field.is_hidden %}
    <div style="display:none;">{{ field }}</div>
  {% else %}
    <div class="form-group {% if field.errors %}has-error{% endif %}">

      {% if field|widget_type == 'checkboxinput' %}
        <div class="checkbox">
            <label for="{{ field.id_for_label }}">{{ field }}{{ field.label }}</label>
        </div>
      {% elif field|widget_type == 'radioselect' %}
        {% for radio in field %}
          <div class="radio">
            {% if not hide_labels %}
              <label for="{{ radio.id_for_label }}">{{ radio.tag }}{{ radio.choice_label }}</label>
            {% endif %}
          </div>
        {% endfor %}
      {% elif field|widget_type == 'checkboxselectmultiple' %}
        {% for checkbox in field %}
          <div class="checbox">
            {% if not hide_labels %}
              <label for="{{ checkbox.id_for_label }}">{{ checkbox.tag }}{{ checkbox.choice_label }}</label>
            {% endif %}
          </div>
        {% endfor %}
      {% else %}
        {% if not hide_labels %}
          <label for="{{ field.id_for_label }}" class="control-label">{{ field.label }}</label>
          {% if field.field.required %}
          <span class="required">*</span>
          {% endif %}
          {% if field.name == 'custom_response_time' %}
          <span class="response_time">(h)</span>
          {% endif %}
        {% endif %}
      {{ field|add_class:"form-control"}}
          {% if field.name == 'description' %}
            <span id="edit-ticket-now" style="display:none;">{% now "SHORT_DATETIME_FORMAT" %}</span>
            <span id="edit-ticket-user" style="display:none;"> {{ user.first_name }}, {{ user.last_name }}</span>
          {% endif %}
      {% endif %}

      {% if field.errors %}
        <div class="help-block error">{% for error in field.errors %}{{ error }}{% endfor %}</div>
      {% endif %}

      {% if field.help_text %}
        <div class="help-block">{% trans field.help_text %}</div>
      {% endif %}

    </div>
  {% endif %}
{% endfor %}

hkm/templates/hkm/snippets/generate_codes.html
{% if obj.campaign_codes.exists %}
    <a href="{% url 'admin:hkm_campaigncode_changelist' %}">Kampanjassa on {{ obj.campaign_codes.count }} koodia</a><br>
{% endif %}

<lable>Määrä:&nbsp;</lable>
<input class="vTextField" id="id_amount" maxlength="128" name="amount" type="text" value="20">
<br>
<lable>Prefix:&nbsp;</lable>
<input class="vTextField" id="id_prefix" maxlength="128" name="prefix" type="text">
<br>
<lable>Koodin pituus:&nbsp;</lable>
<input class="vTextField" id="id_length" maxlength="128" name="length" type="text" value="10">
<br>
<button class="button" id="generate-codes" data-href="{% url 'admin:generate-campaign-codes' campaign_id=obj.id %}">Generoi koodit</button>

hkm/templates/hkm/snippets/login.html
{% load i18n %}

<form method="POST" >
  {% if login_form.non_field_errors %}
    <ul>
      {% for error in login_form.non_field_errors %}
       <li>{{ error }}<li>
      {% endfor %}
    </ul>
  {% endif %}
  {% csrf_token %}
  {% include 'hkm/snippets/form_fields.html' with form=login_form %}
  <input type="hidden" name="action" value="login" />
  <button class="hkm-btn hkm-btn--default btn btn-primary" type="submit">{% trans 'Log in' %}</button>
</form>

hkm/templates/hkm/snippets/museum_logo.html
{% if language == 'fi' %}
  <img src="/static/hkm/svg/Logo_fi.svg" alt="{{ alt }}" class="{{ class }}">

{% elif language == 'en' %}
  <img src="/static/hkm/svg/Logo_en.svg" alt="{{ alt }}" class="{{ class }}">

{% elif language == 'sv' %}
  <img src="/static/hkm/svg/Logo_sv.svg" alt="{{ alt }}}" class="{{ class }}">
{% endif %}

hkm/templates/hkm/snippets/nav_basket_counter.html
{% load i18n %}
<a href="{% url 'basket' %}" aria-label="{% trans 'Shopping cart' %}">
  <div class="cart_wrapper">
    {% if request.basket.lines %}
    <div class="cart_text">{% trans 'Shopping cart' %}</div>
    <div class="cart_icons">
      <img class="cart_svg" src="/static/hkm/svg/ShoppingCart.svg" alt="">
      <div class="cart_counter">{{ request.basket.product_count }}</div>
    </div>

    {% else %}
    <div class="cart_text">{% trans 'Shopping cart' %}</div>
    <div class="cart_icons">
      <img class="cart_svg" src="/static/hkm/svg/ShoppingCart.svg" alt="">
    </div>
    {% endif %}
  </div>

</a>

hkm/templates/hkm/snippets/navigation.html
{% load i18n %}

<nav class="navigation">
  <div class="navigation-header">
    <a class="navigation-brand" href="{% url 'hkm_home' %}">
      {% if language == 'fi' %}
        <img alt="Helsinkikuvia.fi logo" src="/static/hkm/svg/Kuvia_fi.svg" class="navigation__logo">

      {% elif language == 'en' %}
        <img alt="Helsinkikuvia.fi logo" src="/static/hkm/svg/Kuvia_en.svg" class="navigation__logo">

      {% elif language == 'sv' %}
        <img alt="Helsinkikuvia.fi Logotyp"  src="/static/hkm/svg/Kuvia_sv.svg" class="navigation__logo">

      {% endif %}
    </a>
  </div>

  <button id="nav-collapse-btn" type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navigation-toggle" aria-expanded="false" aria-controls="navbar">
    <span class="sr-only">Toggle navigation</span>
    <span class="icon-bar"></span>
    <span class="icon-bar"></span>
    <span class="icon-bar"></span>
  </button>

  <div id="navigation-toggle" class="navigation-links collapse navbar-collapse">
    <ul class="nav navbar-nav">
      {% if language == 'fi' %}
        <div class="list-item_lang-wrapper">
          <li><a class="lang" lang="en" aria-label="{% trans 'In English' %}" href="{% url 'hkm_language' %}?lang=en&next={{ current_url }}">EN</a> </li>
          <li><a class="lang" lang="sv" aria-label="{% trans 'På svenska' %}" href="{% url 'hkm_language' %}?lang=sv&next={{ current_url }}">SV</a></li>
        </div>

      {% elif language == 'en' %}
      <div class="list-item_lang-wrapper">
        <li><a class="lang" lang="fi" aria-label="{% trans 'Suomeksi' %}" href="{% url 'hkm_language' %}?lang=fi&next={{ current_url }}">FI</a> </li>
        <li><a class="lang" lang="sv" aria-label="{% trans 'På svenska' %}" href="{% url 'hkm_language' %}?lang=sv&next={{ current_url }}">SV</a></li>
      </div>

      {% elif language == 'sv' %}
      <div class="list-item_lang-wrapper">
        <li><a class="lang" lang="fi" aria-label="{% trans 'Suomeksi' %}" href="{% url 'hkm_language' %}?lang=fi&next={{ current_url }}">FI</a> </li>
        <li><a class="lang" lang="en" aria-label="{% trans 'In English' %}" href="{% url 'hkm_language' %}?lang=en&next={{ current_url }}">EN</a></li>
      </div>

      {% endif %}
      <li class="list-item_search"><a href="{% url 'hkm_search' %}">{% trans 'Search pictures' %}</a><li>
      <li class="list-item_collection"><a href="{% url 'hkm_public_collections' %}">{% trans 'Explore collections' %}</a></li>
      {% if not user.profile.is_museum %}
      {% if user.is_authenticated %}
      <li class="list-item_user">
        <a id="profile-dropdown" aria-label="{{ user }} {% trans 'Profile menu' %}" class="nav-user" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          <span>{{ user }}</span>
          <img class="nav-svg" src="/static/hkm/svg/Person.svg" alt="" >
        </a>
        <ul class="dropdown-menu">
          <li><a href="{% url 'hkm_my_collections' %}">{% trans 'My collections' %}</a></li>
          <li><a href="{% url 'logout' %}?next=/">{% trans 'Logout' %}</a></li>
        </ul>
      </li>
      {% else %}
      <li class="list-item_login"><a href="#" id="login-btn" data-toggle="modal" data-target="#login">{% trans 'Log in' %}</a></li>
      {% endif %}
      {% endif %}
      <li class="list-item_cart">
        {% include 'hkm/snippets/nav_basket_counter.html' %}
      </li>
    </ul>
  </div>
</nav>

hkm/templates/hkm/snippets/no_results.html
{% load i18n hkm_tags %}
<div class="status-page">
  <img class="status-page__image" src="/static/hkm/img/no-results-image.jpg"></img>
  {% if search_result %}
    <h1 class="status-page__title">{% trans 'No search results' %}</h1>
  {% else %}
    <h1 class="status-page__title">{% trans 'Oops, there was an error, try again soon.' %}</h1>
  {% endif %}
</div>

hkm/templates/hkm/snippets/not_responding.html
{% load i18n hkm_tags %}
<div class="status-page">
  <img class="status-page__image" src="/static/hkm/img/no-results-image.jpg"></img>
  <h1 class="status-page__title">{% trans 'Finnas material server is not responding' %}</h1>
</div>

hkm/templates/hkm/snippets/popover_cart.html
{% load i18n %}
<div id="popover-cart-content">
  <ul class="popover-list">
    {% if full_res_image_url %}
      <li class="popover-list__item"><a download class="popover-list__btn" href="{{ full_res_image_url }}">{% trans 'Download printable image' %}</a></li>
    {% endif %}
    {% if web_image_url %}
    <li class="popover-list__item"><a download class="popover-list__btn" href="{{ cropped_web_image_url }}">{% trans 'Download web-image' %}</a></li>
    {% endif %}
    <li class="popover-list__item"><button class="popover-list__btn popover-list__btn--crop actions_crop" data-img-url="{{ web_image_url }}" data-record-id="{{ finna_id }}" data-toggle="modal" data-target="#crop-and-download">{% trans 'Crop and download' %}</button></li>
    <!-- {% if full_res_image_url %}
      <li class="popover-list__item"><a class="popover-list__btn" href="{% url 'hkm_order_create' finna_id=finna_id %}">{% trans 'Order a product of the image' %}</a></li>
    {% else %}
      <li class="popover-list__item">{% trans 'This is a low resolution image, product orders are not available' %}</li>
    {% endif %} -->
  </ul>
</div>

hkm/templates/hkm/snippets/search_records_grid.html
{% load hkm_tags %}
{% load i18n %}

<div class="grid__group item-slider invisible">
{% for record in search_result.records %}
  <div class="grid__item item" data-w="" data-h="" name="{{ search_term }}_{{ record.index }}">
    <a class="grid__item--buy" href="#" data-toggle="tooltip" title="{% trans 'Buy' %}" aria-label="{% trans 'Buy this as a poster' %}" data-action="{% url 'hkm_order_create' finna_id=record.id %}">
      <svg class="svg-icon">
          <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#icon-shopping"></use>
        </svg>
    </a>
    <a href="{% url 'hkm_search_record' %}?image_id={{ record.id }}">
      <img class="flex-img" src="{% finna_image record.id w=400 h=400 %}" alt="{{ record.title }}"></img>
    </a>
    <div class="grid__meta">
      <span class="grid__meta--title">{{ record.title }}</span>
      <span class="grid__meta--other">{% for author in record.rawData.author %}{{ author }}{% endfor %} {{ record.rawData.era.0|default:"" }}</span>
      {% if user.is_authenticated %}
        <button aria-label="{% trans 'Add to favorites' %}" class="grid__fav {% if record.is_favorite %}active{% endif %}" data-record-id="{{ record.id }}">
            <i class="grid__fav-icon">
              <svg class="svg-icon">
                <title>{% trans 'Add to favorites' %}</title>
                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#icon-heart-stroke"></use>
              </svg>
            </i>
          </button>
      {% endif %}
    </div>
  </div>
{% endfor %}
</div>

hkm/templates/hkm/snippets/signup.html
{% load i18n %}

<form method="POST">
  {% if sign_up_form.non_field_errors %}
    <ul>
      {% for error in sign_up_form.non_field_errors %}
       <li>{{ error }}<li>
      {% endfor %}
    </ul>
  {% endif %}
  {% csrf_token %}
  {% include 'hkm/snippets/form_fields.html' with form=sign_up_form %}
  <input type="hidden" name="action" value="signup" />
  <button class="hkm-btn hkm-btn--default btn btn-primary" type="submit">{% trans 'Sign up' %}</button>
</form>